<?php
class jn_Analytics
{
	private $code='';
	private $enabled=false;
	private $wp_user_id=false;

	function is_enabled(){return ($this->enabled=='on');}
	function getCode(){return $this->code;}

	public function __construct()
	{
//					delete_option('jn_EPGA');

		$settings=get_option('jn_EPGA');
		if($settings!=false)
		{
			$this->enabled=$settings["enabled"];
			$this->code=$settings["code"];
			$this->wp_user_id=(isset($settings["wp_user_id"]))?$settings["wp_user_id"]:false;
		}
		else
		{
			$this->enabled=get_option('jn_EPGA_enable',false);
			$this->code=get_option('jn_EPGA_code','');

			/* Version Compatibility */
			$settings=[];
			$settings["code"]=$this->code;
			$settings["enabled"]=$this->enabled;
			update_option('jn_EPGA', $settings);
			delete_option('jn_EPGA_enable');
			delete_option('jn_EPGA_code');
			/* End Version Compatibility */
		}
	}

	private function checkboxSetting($property)
	{
		return ($this->$property=='on')?' checked="checked"':'';
	}

	public function putAdminOptions()
	{
		echo '
          <table class="form-table">
          <tr>
            	<th>'.__('Enable Analytics','easy-pixels-by-jevnet').'</th>
            	<td style="width:3em"><input type="checkbox" id="jn_EPGA_enable" name="jn_EPGA_enable"'.$this->checkboxSetting('enabled').'></td>
				<td><input value="'.$this->code.'" type="text" id="jn_EPGA_code" name="jn_EPGA_code" placeholder="UA-XXXXXXXX-X" pattern="UA-[0-9]+-[0-9]+"><!-- <input type="checkbox" id="jn_EPGA_overwriteUserId" name="jn_EPGA_overwriteUserId"'.$this->checkboxSetting('wp_user_id').'>'.__('If user is logged in overwrite session ID','easy-pixels-by-jevnet').' --></td>
				<th></th>
          </tr>
     </table>';
	}

	public function putTrackingCode()
	{
		if($this->code!='')
		{
			if(($this->wp_user_id)&&(get_current_user_id()!==0))
			{
				$userid="{'user_id': '".get_current_user_id()."'}";
				echo "gtag('config', '".$this->code."',".$userid.");";
				echo "gtag('set', 'dimension1','USER_ID');";
			}
			else
			{
				echo "gtag('config', '".$this->code."');";
			}
		}
	}

	static public function save($WP_settings_group='jnEasyPixelsSettings-group')
	{
		if(isset($_POST["jn_EPGA_code"]))
		{
			$settings=get_option('jn_EPGA');
			if($settings==false){$settings=[];}
			$settings["code"]=self::sanitizeUAcode($_POST["jn_EPGA_code"]);
			$settings["enabled"]=(isset($_POST["jn_EPGA_enable"]));
			$settings["wp_user_id"]=(isset($_POST["jn_EPGA_overwriteUserId"]));
			update_option('jn_EPGA', $settings);
		}
	}

	static function sanitizeUAcode($theLabel='')
	{
		$theLabel=sanitize_text_field(strtoupper($theLabel));
		$theLabel=(preg_match('/UA\-[0-9]+\-[0-9]+/', $theLabel))?$theLabel:'';
		return $theLabel;
	}

	static function sanitizeCheckbox($theCheck='')
	{
		$theCheck=sanitize_text_field(strtolower($theCheck));
		return $theCheck;
	}
}
?>